<?php
/**
 * Ipay88
 * @author Ipay88
 * @package Ipay88\Lib
 */

class ipay88_OC_Indonesia
{
    const URL_PAYMENT_PRODUCTION 				= 'https://payment.ipay88.co.id/PG';
    const URL_PAYMENT_SANDBOX    				= 'https://sandbox.ipay88.co.id/PG';
    const URL_PAYMENTAPI_PRODUCTION    				= 'https://payment.ipay88.co.id/epayment/webservice/paymentapi/checkout';
    const URL_PAYMENTAPI_SANDBOX    				= 'https://sandbox.ipay88.co.id/epayment/webservice/paymentapi/checkout';

    const PAYMENT_METHOD_ENABLE 				= 1;
    const PAYMENT_METHOD_DISABLE				= 2;
	
    const MERCHANT_CODE 						= 'ipay88_oc_merchant_code';
    const MERCHANT_KEY  						= 'ipay88_oc_merchant_key';
    const PAYMENT_MODE  						= 'ipay88_oc_payment_mode';

    const PAYMENT_METHOD_OC_KREDIVO				= 55;
	const PAYMENT_METHOD_OC_AKULAKU			= 71;
	const PAYMENT_METHOD_OC_ATOME		= 73;
	const PAYMENT_METHOD_OC_INDODANA		= 70;
	
	const PAYMENT_METHOD_OC_KREDIVO_CONFIG				= 'ipay88_oc_kredivo_config';
    const PAYMENT_METHOD_OC_AKULAKU_CONFIG				= 'ipay88_oc_akulaku_config';
    const PAYMENT_METHOD_OC_INDODANA_CONFIG				= 'ipay88_oc_indodana_config';
    const PAYMENT_METHOD_OC_ATOME_CONFIG				= 'ipay88_oc_atome_config';
    
			
	const PAYMENT_METHOD_OC_KREDIVO_LABEL		= 'Kredivo';
	const PAYMENT_METHOD_OC_AKULAKU_LABEL		= 'Akulaku';
	const PAYMENT_METHOD_OC_ATOME_LABEL		= 'Atome';
	const PAYMENT_METHOD_OC_INDODANA_LABEL		= 'Indodana';
	
	// function
    public function getBanksConfigs() 
	{
		return array(	
            self::PAYMENT_METHOD_OC_KREDIVO_CONFIG,
            self::PAYMENT_METHOD_OC_AKULAKU_CONFIG,
            self::PAYMENT_METHOD_OC_INDODANA_CONFIG,
            self::PAYMENT_METHOD_OC_ATOME_CONFIG,
		);
    }

    public function getFieldsConfigs() 
	{
        return array(	
            self::MERCHANT_CODE,
            self::MERCHANT_KEY,
            self::PAYMENT_MODE,			
            self::PAYMENT_METHOD_OC_KREDIVO_CONFIG, 			
            self::PAYMENT_METHOD_OC_AKULAKU_CONFIG,
            self::PAYMENT_METHOD_OC_INDODANA_CONFIG,
            self::PAYMENT_METHOD_OC_ATOME_CONFIG,
        );
    }

    protected $paymentMethod;
	protected $description;
	protected $banks;
    protected $bankKeyConfig;
    protected $paymentId;
    protected $bankName;
    protected $logo;
    protected $imagePath;
    protected $bankEnabled;
    
	// @return array
    public function getBankEnabled()
    {
        return $this->bankEnabled;
    }

    // @param mixed $bankEnabled
    public function setBankEnabled($bankEnabled)
    {
        $this->bankEnabled = $bankEnabled;
    }

    // @return mixed
    public function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    // @param mixed $paymentMethod
    public function setPaymentMethod($paymentMethod)
    {
        $this->paymentMethod = $paymentMethod;
    }

    // @return mixed
    public function getBanks()
    {
        return $this->banks;
    }

    // @param mixed $banks
    public function setBanks($banks)
    {
        $this->banks = $banks;
    }

    // @return mixed
    public function getBankKeyConfig()
    {
        return $this->bankKeyConfig;
    }

    // @param mixed $bankKeyConfig
    public function setBankKeyConfig($bankKeyConfig)
    {
        $this->bankKeyConfig = $bankKeyConfig;
    }

    // @return mixed
    public function getPaymentId()
    {
        return $this->paymentId;
    }

    // @param mixed $paymentId
    public function setPaymentId($paymentId)
    {
        $this->paymentId = $paymentId;
    }

    // @return mixed
    public function getBankName()
    {
        return $this->bankName;
    }

    // @param mixed $bankName
    public function setBankName($bankName)
    {
        $this->bankName = $bankName;
    }

	// @return mixed
    public function getLogo()
    {
        return $this->logo;
    }

    // @param mixed $logo
    public function setLogo($logo)
    {
        $this->logo = $logo;
    }

    // @return mixed
    public function getImagePath()
    {
        return $this->imagePath;
    }

    // @param mixed $imagePath
    public function setImagePath($imagePath)
    {
        $this->imagePath = $imagePath;
    }

    // Payment methods, please view technical spec for latest update.
    protected $pMethod = array(  
		self::PAYMENT_METHOD_OC_KREDIVO_CONFIG  => 
		array(	'paymentId' => self::PAYMENT_METHOD_OC_KREDIVO,
            	'name' 		=> self::PAYMENT_METHOD_OC_KREDIVO_LABEL,
            	'logo' 		=> 'kredivo.png'),
        self::PAYMENT_METHOD_OC_AKULAKU_CONFIG  => 
        array(	'paymentId' => self::PAYMENT_METHOD_OC_AKULAKU,
                'name' 		=> self::PAYMENT_METHOD_OC_AKULAKU_LABEL,
                'logo' 		=> 'akulaku.png'),
        self::PAYMENT_METHOD_OC_INDODANA_CONFIG  => 
        array(	'paymentId' => self::PAYMENT_METHOD_OC_INDODANA,
                'name' 		=> self::PAYMENT_METHOD_OC_INDODANA_LABEL,
                'logo' 		=> 'indodana.png'),
        self::PAYMENT_METHOD_OC_ATOME_CONFIG  => 
        array(	'paymentId' => self::PAYMENT_METHOD_OC_ATOME,
                'name' 		=> self::PAYMENT_METHOD_OC_ATOME_LABEL,
                'logo' 		=> 'atome.png'),
    );

    // @return array
    public function getPmethod() 
	{
        return $this->pMethod;
    }

    // Payment methods, please view technical spec for latest update.
    public $paymentMethods = array(
						
		self::PAYMENT_METHOD_OC_KREDIVO_CONFIG  => 
		array(	'name' 	=> self::PAYMENT_METHOD_OC_KREDIVO_LABEL,
            	'logo' 		=> 'kredivo.png'),
        self::PAYMENT_METHOD_OC_AKULAKU_CONFIG  => 
        array(	'name' 		=> self::PAYMENT_METHOD_OC_AKULAKU_LABEL,
                'logo' 		=> 'akulaku.png'),
        self::PAYMENT_METHOD_OC_INDODANA_CONFIG  => 
        array(	'name' 		=> self::PAYMENT_METHOD_OC_INDODANA_LABEL,
                'logo' 		=> 'indodana.png'),
        self::PAYMENT_METHOD_OC_ATOME_CONFIG  => 
        array(	'name' 		=> self::PAYMENT_METHOD_OC_ATOME_LABEL,
                'logo' 		=> 'atome.png'),
	);

    // @param $key
    // @return null
    public function getPaymentMethodInfoByKey($key) 
	{
        if(isset($this->pMethod[$key])) 
		{
            return $this->pMethod[$key];
        }
        
		return null;
    }

    // @param $id
    // @return null
    public function getPaymentMethodInfoById($id) 
	{
        if(isset($this->pMethod[$id])) 
		{
            return $this->pMethod[$id];
        }
        
		return null;
    }

    public function __construct($options = null)
    {
    }

	//payment checkout
    public function getWiget($banks, $description, $imagePath, $auto = false) 
	{
        $bankConfigurations = $banks;
		
        $html = $description.'<br><br>			
		<p class="form-row">
		<label for="ipay88_payment_type">PaymentType
		<span class="required">*</span></label>
		</p>
		
		<div class="payment_method_ipay88">
		<fieldset>
		<legend>Please choose one to pay</legend>';
				
		if(is_array($bankConfigurations) && count($bankConfigurations)) 
		{
			foreach ($bankConfigurations as $key => $config) 
			{
				if($config) 
				{
					$bank = $this->getPaymentMethodInfoByKey($key);
					
					if(is_array($bank) && count($bank)) 
					{
						$paymentId	= isset($bank['paymentId']) ? $bank['paymentId'] : '';
						$name 		= isset($bank['name']) ? $bank['name'] : '';
						$logo 		= $imagePath . DIRECTORY_SEPARATOR . (isset($bank['logo']) ? $bank['logo'] : '');

						$html .= '<div><label style="margin-bottom:5px;display:inline-flex;align-items:center;">
						<input type="radio" name="ipay88_bank_payment_method" value="'.$paymentId.'" checked>
						<img class="ipay88_bank_payment_method" src="'.$logo.'" alt="'.$name.'" style="float:none; max-width:8.5em; margin-left:1em; max-height: 50px;"></label></div>';
					}
				}
			}
		}
		
		$html .= '</fieldset></div>';
		
        return $html;
    }
}